Package: geb

## [Groovy] Class Module

- geb.Module

- All Implemented Interfaces and Traits:
    Initializable, Navigator, PageContentContainer, WaitingSupport

      class Module
      extends Object

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected Browser` | `browser` |
    `protected Navigator` | `navigator` |

  - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `static def` | `base`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `Navigator` | `$(Map<String, Object> predicates)`
    `` | `Navigator` | `$(Map<String, Object> predicates, int index)`
    `` | `Navigator` | `$(Map<String, Object> predicates, Range<Integer> range)`
    `` | `Navigator` | `$(Map<String, Object> predicates, String selector)`
    `` | `Navigator` | `$(Map<String, Object> predicates, String selector, int index)`
    `` | `Navigator` | `$(Map<String, Object> predicates, String selector, Range<Integer> range)`
    `` | `Navigator` | `$(String selector)`
    `` | `Navigator` | `$(String selector, int index)`
    `` | `Navigator` | `$(String selector, Range<Integer> range)`
    `` | `Navigator` | `$(Map<String, Object> predicates, By bySelector)`
    `` | `Navigator` | `$(Map<String, Object> predicates, By bySelector, int index)`
    `` | `Navigator` | `$(Map<String, Object> predicates, By bySelector, Range<Integer> range)`
    `` | `Navigator` | `$(By bySelector)`
    `` | `Navigator` | `$(By bySelector, int index)`
    `` | `Navigator` | `$(By bySelector, Range<Integer> range)`
    `` | `Navigator` | `add(Collection<WebElement> elements)`
    `` | `Navigator` | `add(WebElement[] elements)`
    `` | `Navigator` | `add(By bySelector)`
    `` | `Navigator` | `add(String selector)`
    `` | `Collection<WebElement>` | `allElements()`
    `` | `boolean` | `asBoolean()`
    `` | `String` | `attr(String name)`
    `` | `Navigator` | `children(Map<String, Object> attributes = [:], String selector)`
    `` | `Navigator` | `children(Map<String, Object> attributes)`
    `` | `Navigator` | `children()`
    `` | `List<String>` | `classes()`
    `` | `Navigator` | `click(List potentialPages, Wait wait = null)`
    `` | `Navigator` | `click(Page pageInstance, Wait wait = null)`
    `` | `Navigator` | `click(Class<? extends Page> pageClass, Wait wait = null)`
    `` | `Navigator` | `click()`
    `` | `Navigator` | `closest(Map<String, Object> attributes = [:], String selector)`
    `` | `Navigator` | `closest(Map<String, Object> attributes)`
    `` | `String` | `css(String propertyName)`
    `` | `Iterator<WebElement>` | `elementIterator()`
    `` | `Navigator` | `eq(int index)`
    `` | `boolean` | `equals(Object obj)`
    `` | `Navigator` | `filter(Map<String, Object> predicates = [:], String selector)`
    `` | `Navigator` | `filter(Map<String, Object> predicates)`
    `` | `Navigator` | `find(Map<String, Object> predicates)`
    `` | `Navigator` | `find(Map<String, Object> predicates, int index)`
    `` | `Navigator` | `find(Map<String, Object> predicates, Range<Integer> range)`
    `` | `Navigator` | `find(Map<String, Object> predicates, String selector)`
    `` | `Navigator` | `find(Map<String, Object> predicates, String selector, int index)`
    `` | `Navigator` | `find(Map<String, Object> predicates, String selector, Range<Integer> range)`
    `` | `Navigator` | `find(String selector)`
    `` | `Navigator` | `find(String selector, int index)`
    `` | `Navigator` | `find(String selector, Range<Integer> range)`
    `` | `Navigator` | `find(Map<String, Object> predicates, By bySelector)`
    `` | `Navigator` | `find(Map<String, Object> predicates, By bySelector, int index)`
    `` | `Navigator` | `find(Map<String, Object> predicates, By bySelector, Range<Integer> range)`
    `` | `Navigator` | `find(By bySelector)`
    `` | `Navigator` | `find(By bySelector, int index)`
    `` | `Navigator` | `find(By bySelector, Range<Integer> range)`
    `` | `Navigator` | `findAll(Closure predicate)`
    `` | `Navigator` | `first()`
    `` | `WebElement` | `firstElement()`
    `` | `Navigator` | `getAt(Collection indexes)`
    `` | `Navigator` | `getAt(Range range)`
    `` | `Navigator` | `getAt(int index)`
    `` | `String` | `getAttribute(String name)`
    `` | `List<String>` | `getContentPath()`
    `` | `protected boolean` | `getHasOwner()`
    `` | `int` | `getHeight()`
    `` | `protected Navigator` | `getInitializedNavigator()`
    `` | `JQueryAdapter` | `getJquery()`
    `` | `JavascriptInterface` | `getJs()`
    `` | `PageContentContainer` | `getRootContainer()`
    `` | `String` | `getStringRepresentation()`
    `` | `int` | `getWidth()`
    `` | `int` | `getX()`
    `` | `int` | `getY()`
    `` | `Navigator` | `has(Map<String, Object> predicates = [:], By bySelector)`
    `` | `Navigator` | `has(Map<String, Object> predicates)`
    `` | `Navigator` | `has(Map<String, Object> predicates = [:], String selector)`
    `` | `boolean` | `hasClass(String className)`
    `` | `Navigator` | `hasNot(Map<String, Object> predicates)`
    `` | `Navigator` | `hasNot(Map<String, Object> predicates = [:], String selector)`
    `` | `Navigator` | `hasNot(Map<String, Object> predicates = [:], By bySelector)`
    `` | `int` | `hashCode()`
    `` | `Navigator` | `head()`
    `` | `void` | `init(Browser browser, NavigatorFactory navigatorFactory)`
    `` | `void` | `init(PageContentTemplate template, Object[] args)`
    `` | `protected void` | `initialized()`
    `` | `boolean` | `is(String tag)`
    `` | `boolean` | `isDisplayed()`
    `` | `boolean` | `isEmpty()`
    `` | `boolean` | `isFocused()`
    `` | `Iterator<Navigator>` | `iterator()`
    `` | `Navigator` | `last()`
    `` | `WebElement` | `lastElement()`
    `` | `Navigator` | `leftShift(def value)`
    `` | `def` | `methodMissing(String name, def args)`
    `<T extends Module>` | `T` | `module(Class<T> moduleClass)`
    `<T extends Module>` | `T` | `module(T module)`
    `<T extends Module>` | `List<T>` | `moduleList(Class<T> moduleClass)`
    `<T extends Module>` | `List<T>` | `moduleList(Closure<T> moduleFactory)`
    `` | `Navigator` | `next(Map<String, Object> attributes = [:], String selector)`
    `` | `Navigator` | `next(Map<String, Object> attributes)`
    `` | `Navigator` | `next()`
    `` | `Navigator` | `nextAll(Map<String, Object> attributes = [:], String selector)`
    `` | `Navigator` | `nextAll(Map<String, Object> attributes)`
    `` | `Navigator` | `nextAll()`
    `` | `Navigator` | `nextUntil(Map<String, Object> attributes = [:], String selector)`
    `` | `Navigator` | `nextUntil(Map<String, Object> attributes)`
    `` | `Navigator` | `not(Map<String, Object> predicates = [:], String selector)`
    `` | `Navigator` | `not(Map<String, Object> predicates)`
    `` | `Navigator` | `parent(Map<String, Object> attributes = [:], String selector)`
    `` | `Navigator` | `parent(Map<String, Object> attributes)`
    `` | `Navigator` | `parent()`
    `` | `Navigator` | `parents(Map<String, Object> attributes = [:], String selector)`
    `` | `Navigator` | `parents(Map<String, Object> attributes)`
    `` | `Navigator` | `parents()`
    `` | `Navigator` | `parentsUntil(Map<String, Object> attributes = [:], String selector)`
    `` | `Navigator` | `parentsUntil(Map<String, Object> attributes)`
    `` | `Navigator` | `plus(Navigator navigator)`
    `` | `Navigator` | `prevAll(Map<String, Object> attributes = [:], String selector)`
    `` | `Navigator` | `prevAll(Map<String, Object> attributes)`
    `` | `Navigator` | `prevAll()`
    `` | `Navigator` | `prevUntil(Map<String, Object> attributes = [:], String selector)`
    `` | `Navigator` | `prevUntil(Map<String, Object> attributes)`
    `` | `Navigator` | `previous(Map<String, Object> attributes = [:], String selector)`
    `` | `Navigator` | `previous(Map<String, Object> attributes)`
    `` | `Navigator` | `previous()`
    `` | `def` | `propertyMissing(String name)`
    `` | `def` | `propertyMissing(String name, def val)`
    `` | `Navigator` | `remove(int index)`
    `` | `Navigator` | `siblings(Map<String, Object> attributes = [:], String selector)`
    `` | `Navigator` | `siblings(Map<String, Object> attributes)`
    `` | `Navigator` | `siblings()`
    `` | `WebElement` | `singleElement()`
    `` | `int` | `size()`
    `` | `String` | `tag()`
    `` | `Navigator` | `tail()`
    `` | `String` | `text()`
    `` | `String` | `toString()`
    `` | `GebException` | `uninitializedException()`
    `` | `Navigator` | `unique()`
    `` | `Navigator` | `value(def value)`
    `` | `def` | `value()`
    `` | `Navigator` | `verifyNotEmpty()`
    `<T>` | `T` | `waitFor(Map params = [:], String waitPreset, Closure<T> block)`
    `<T>` | `T` | `waitFor(Map params = [:], Closure<T> block)`
    `<T>` | `T` | `waitFor(Map params = [:], Number timeout, Closure<T> block)`
    `<T>` | `T` | `waitFor(Map params = [:], Number timeout, Number interval, Closure<T> block)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### protected Browser browser

    - #### protected Navigator navigator

  - ### Property Detail

    - #### static def base

  - ### Method Detail

    - #### @Override Navigator $(Map<String, Object> predicates)

    - #### @Override Navigator $(Map<String, Object> predicates, int index)

    - #### @Override Navigator $(Map<String, Object> predicates, Range<Integer> range)

    - #### @Override Navigator $(Map<String, Object> predicates, String selector)

    - #### @Override Navigator $(Map<String, Object> predicates, String selector, int index)

    - #### @Override Navigator $(Map<String, Object> predicates, String selector, Range<Integer> range)

    - #### @Override Navigator $(String selector)

    - #### @Override Navigator $(String selector, int index)

    - #### @Override Navigator $(String selector, Range<Integer> range)

    - #### @Override Navigator $(Map<String, Object> predicates, By bySelector)

    - #### @Override Navigator $(Map<String, Object> predicates, By bySelector, int index)

    - #### @Override Navigator $(Map<String, Object> predicates, By bySelector, Range<Integer> range)

    - #### @Override Navigator $(By bySelector)

    - #### @Override Navigator $(By bySelector, int index)

    - #### @Override Navigator $(By bySelector, Range<Integer> range)

    - #### @Override Navigator add(Collection<WebElement> elements)

    - #### @Override Navigator add(WebElement[] elements)

    - #### @Override Navigator add(By bySelector)

    - #### @Override Navigator add(String selector)

    - #### @Override Collection<WebElement> allElements()

    - #### boolean asBoolean()

    - #### @Override String attr(String name)

    - #### @Override Navigator children(Map<String, Object> attributes = [:], String selector)

    - #### @Override Navigator children(Map<String, Object> attributes)

    - #### @Override Navigator children()

    - #### @Override List<String> classes()

    - #### @Override Navigator click(List potentialPages, Wait wait = null)

    - #### @Override Navigator click(Page pageInstance, Wait wait = null)

    - #### @Override Navigator click(Class<? extends Page> pageClass, Wait wait = null)

    - #### @Override Navigator click()

    - #### @Override Navigator closest(Map<String, Object> attributes = [:], String selector)

    - #### @Override Navigator closest(Map<String, Object> attributes)

    - #### @Override String css(String propertyName)

    - #### @Override Iterator<WebElement> elementIterator()

    - #### @Override Navigator eq(int index)

    - #### @Override boolean equals(Object obj)

    - #### @Override Navigator filter(Map<String, Object> predicates = [:], String selector)

    - #### @Override Navigator filter(Map<String, Object> predicates)

    - #### @Override Navigator find(Map<String, Object> predicates)

    - #### @Override Navigator find(Map<String, Object> predicates, int index)

    - #### @Override Navigator find(Map<String, Object> predicates, Range<Integer> range)

    - #### @Override Navigator find(Map<String, Object> predicates, String selector)

    - #### @Override Navigator find(Map<String, Object> predicates, String selector, int index)

    - #### @Override Navigator find(Map<String, Object> predicates, String selector, Range<Integer> range)

    - #### @Override Navigator find(String selector)

    - #### @Override Navigator find(String selector, int index)

    - #### @Override Navigator find(String selector, Range<Integer> range)

    - #### @Override Navigator find(Map<String, Object> predicates, By bySelector)

    - #### @Override Navigator find(Map<String, Object> predicates, By bySelector, int index)

    - #### @Override Navigator find(Map<String, Object> predicates, By bySelector, Range<Integer> range)

    - #### @Override Navigator find(By bySelector)

    - #### @Override Navigator find(By bySelector, int index)

    - #### @Override Navigator find(By bySelector, Range<Integer> range)

    - #### @Override Navigator findAll(Closure predicate)

    - #### @Override Navigator first()

    - #### @Override WebElement firstElement()

    - #### @Override @SuppressWarnings("ExplicitCallToGetAtMethod") Navigator getAt(Collection indexes)

    - #### @Override Navigator getAt(Range range)

    - #### @Override Navigator getAt(int index)

    - #### @Override String getAttribute(String name)

    - #### @Override List<String> getContentPath()

    - #### protected boolean getHasOwner()

    - #### @Override int getHeight()

    - #### protected Navigator getInitializedNavigator()

    - #### @Override JQueryAdapter getJquery()

    - #### JavascriptInterface getJs()

    - #### @Override PageContentContainer getRootContainer()

    - #### String getStringRepresentation()

    - #### @Override int getWidth()

    - #### @Override int getX()

    - #### @Override int getY()

    - #### @Override Navigator has(Map<String, Object> predicates = [:], By bySelector)

    - #### @Override Navigator has(Map<String, Object> predicates)

    - #### @Override Navigator has(Map<String, Object> predicates = [:], String selector)

    - #### @Override boolean hasClass(String className)

    - #### @Override Navigator hasNot(Map<String, Object> predicates)

    - #### @Override Navigator hasNot(Map<String, Object> predicates = [:], String selector)

    - #### @Override Navigator hasNot(Map<String, Object> predicates = [:], By bySelector)

    - #### @Override int hashCode()

    - #### @Override Navigator head()

    - #### void init(Browser browser, NavigatorFactory navigatorFactory)

    - #### void init(PageContentTemplate template, Object[] args)

    - #### @SuppressWarnings("EmptyMethod") protected void initialized()

    - #### @Override boolean is(String tag)

    - #### @Override boolean isDisplayed()

    - #### @Override boolean isEmpty()

    - #### @Override boolean isFocused()

    - #### @Override Iterator<Navigator> iterator()

    - #### @Override Navigator last()

    - #### @Override WebElement lastElement()

    - #### @Override Navigator leftShift(def value)

    - #### def methodMissing(String name, def args)

    - #### <T extends Module> @Override T module(Class<T> moduleClass)

    - #### <T extends Module> @Override T module(T module)

    - #### <T extends Module> @Override List<T> moduleList(Class<T> moduleClass)

    - #### <T extends Module> @Override List<T> moduleList(Closure<T> moduleFactory)

    - #### @Override Navigator next(Map<String, Object> attributes = [:], String selector)

    - #### @Override Navigator next(Map<String, Object> attributes)

    - #### @Override Navigator next()

    - #### @Override Navigator nextAll(Map<String, Object> attributes = [:], String selector)

    - #### @Override Navigator nextAll(Map<String, Object> attributes)

    - #### @Override Navigator nextAll()

    - #### @Override Navigator nextUntil(Map<String, Object> attributes = [:], String selector)

    - #### @Override Navigator nextUntil(Map<String, Object> attributes)

    - #### @Override Navigator not(Map<String, Object> predicates = [:], String selector)

    - #### @Override Navigator not(Map<String, Object> predicates)

    - #### @Override Navigator parent(Map<String, Object> attributes = [:], String selector)

    - #### @Override Navigator parent(Map<String, Object> attributes)

    - #### @Override Navigator parent()

    - #### @Override Navigator parents(Map<String, Object> attributes = [:], String selector)

    - #### @Override Navigator parents(Map<String, Object> attributes)

    - #### @Override Navigator parents()

    - #### @Override Navigator parentsUntil(Map<String, Object> attributes = [:], String selector)

    - #### @Override Navigator parentsUntil(Map<String, Object> attributes)

    - #### @Override Navigator plus(Navigator navigator)

    - #### @Override Navigator prevAll(Map<String, Object> attributes = [:], String selector)

    - #### @Override Navigator prevAll(Map<String, Object> attributes)

    - #### @Override Navigator prevAll()

    - #### @Override Navigator prevUntil(Map<String, Object> attributes = [:], String selector)

    - #### @Override Navigator prevUntil(Map<String, Object> attributes)

    - #### @Override Navigator previous(Map<String, Object> attributes = [:], String selector)

    - #### @Override Navigator previous(Map<String, Object> attributes)

    - #### @Override Navigator previous()

    - #### def propertyMissing(String name)

    - #### def propertyMissing(String name, def val)

    - #### @Override Navigator remove(int index)

    - #### @Override Navigator siblings(Map<String, Object> attributes = [:], String selector)

    - #### @Override Navigator siblings(Map<String, Object> attributes)

    - #### @Override Navigator siblings()

    - #### @Override WebElement singleElement()

    - #### @Override int size()

    - #### @Override String tag()

    - #### @Override Navigator tail()

    - #### @Override String text()

    - #### @Override String toString()

    - #### GebException uninitializedException()

    - #### @Override Navigator unique()

    - #### @Override Navigator value(def value)

    - #### @Override def value()

    - #### @Override Navigator verifyNotEmpty()

    - #### <T> @Override T waitFor(Map params = [:], String waitPreset, Closure<T> block)

    - #### <T> @Override T waitFor(Map params = [:], Closure<T> block)

    - #### <T> @Override T waitFor(Map params = [:], Number timeout, Closure<T> block)

    - #### <T> @Override T waitFor(Map params = [:], Number timeout, Number interval, Closure<T> block)